/**
 * DevExtreme (core/utils/deferred.js)
 * Version: 17.2.0 (build 17248)
 * Build date: Tue Sep 05 2017
 *
 * Copyright (c) 2012 - 2017 Developer Express Inc. ALL RIGHTS RESERVED
 * Read about DevExtreme licensing here: https://js.devexpress.com/Licensing/
 */
"use strict";
var jQuery = require("jquery");
var compareVersion = require("../utils/version").compare;
var typeUtils = require("../utils/type");
var Deferred = jQuery.Deferred;
module.exports.Deferred = Deferred;
module.exports.fromPromise = function(promise, context) {
    if (typeUtils.isDeferred(promise)) {
        return promise
    } else {
        if (typeUtils.isPromise(promise)) {
            var d = new Deferred;
            promise.then(function() {
                d.resolveWith.apply(d, [context].concat([
                    [].slice.call(arguments)
                ]))
            }, function() {
                d.rejectWith.apply(d, [context].concat([
                    [].slice.call(arguments)
                ]))
            });
            return d
        }
    }
    return (new Deferred).resolveWith(context, [promise])
};
module.exports.when = compareVersion(jQuery.fn.jquery, [3]) < 0 ? jQuery.when : function(singleArg) {
    if (0 === arguments.length) {
        return (new Deferred).resolve()
    } else {
        if (1 === arguments.length) {
            return singleArg && singleArg.then ? singleArg : (new Deferred).resolve(singleArg)
        } else {
            return jQuery.when.apply(jQuery, arguments)
        }
    }
};
